#pragma once
#ifndef SYNTH_H
#define SYNTH_H

#include <list>
#include "SDL.h"

//INCOMPLETE

/*
Generative Music using Cellular Automata
Tech Demo

by Brian MacIntosh

V0.5: 12/10/12

You are free to modify and distribute this code or binaries for commercial
or non-commercial purposes, provided this header remains intact.
No warranty of fitness for any purpose, express or implied, is given.
*/

class Synth
{
public:
	Synth();

	//Render and advance the sound from this synth
	void Render(Uint8* stream, int len, SDL_AudioSpec audioFormat);

	//Play a tone with this synth
	void PlayTone(double freq, int dur);

	//Set the waveform used by this synth
	void SetWaveform();

	//Set the ADSR values of this synth, in ms
	void SetADSR(int a, int d, double s, int r);

protected:
	struct Tone
	{
	public:
		Tone(double freq, int dur);

		//Is this tone completely silenced?
		bool Ended(SDL_AudioSpec audioFormat, int r) const;

		double frequency;
		int duration;
		int period;
	};

	std::list<Tone> tones;

	int a;
	int d;
	double s;
	int r;
};

#endif